%define name	john
%define version	1.6.37
%define release	1mdk

%define enable_optimize 1
%{?_without_optimize: %global enable_optimize 0}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	John the Ripper password cracker
License:	GPL
Group:		Monitoring
Source0:	http://www.openwall.com/john/b/%{name}-%{version}.tar.gz
Source1:	http://www.openwall.com/john/b/%{name}-%{version}.tar.gz.sign
Source2:	http://www.openwall.com/john/b/%{name}-1.6.tar.gz
Source3:	http://www.openwall.com/john/b/%{name}-1.6.tar.gz.sign
Patch0:		john.makefile.patch.bz2
Patch1:		john-1.6.37-fhs.patch.bz2
Patch2:		john-1.6.37-extra-cflags.patch.bz2
URL:		http://www.openwall.com/john/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
John the Ripper is a fast password cracker, currently available for many
flavors of Unix (11 are officially supported, not counting different
architectures), DOS, Win32, and BeOS. Its primary purpose is to detect
weak Unix passwords, but a number of other hash types are supported as
well.

NOTE: If you want to recompile specifically for your CPU, you can
      rebuild RPM with following option:

	rpmbuild --define='extra_cflags -march=athlon' \
		--rebuild john*.src.rpm

      For x86 or x86_64 CPUs, if you don't want optimization or
      native 64 bit support, you can use '--without optimize' option.

%prep
%setup -q -a 2
#patch0
%patch1 -p1 -b .fhs
%patch2 -p1 -b .extra-cflags
chmod 644 doc/* john-1.6/doc/*

%build
TARGET=""
%ifarch %ix86
%if enable_optimize
	TARGET=linux-x86-mmx-elf
%else
	TARGET=linux-x86-any-elf
%endif
%endif
%ifarch x86_64
%if enable_optimize
	TARGET=linux-x86-64
%else
	TARGET=linux-x86-64-mmx
%endif
%endif
%ifarch ppc
	TARGET=linux-ppc
%endif
%ifarch alpha
	TARGET=linux-alpha
%endif
%ifarch sparc
	TARGET=linux-sparc
%endif

if test -z "$TARGET"; then
	TARGET=generic
	export TARGET
	echo "Please add the right TARGET to the spec file"
fi

cd src
%make $TARGET %{?extra_cflags:EXTRA_CFLAGS="%extra_cflags"}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir} \
         $RPM_BUILD_ROOT%{_datadir}/%{name} \
         $RPM_BUILD_ROOT%{_sysconfdir}

install -m 755 run/{john,mailer} $RPM_BUILD_ROOT%{_bindir}/
# *.chr only present in stable version source
install -m 644 john-1.6/run/*.chr run/password.lst $RPM_BUILD_ROOT%{_datadir}/%{name}/
install -m 644 run/john.conf $RPM_BUILD_ROOT%{_sysconfdir}/

pushd $RPM_BUILD_ROOT%{_bindir}
  ln -s john unafs
  ln -s john unique
  ln -s john unshadow
popd

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc doc/CHANGES john-1.6/doc/*
%config(noreplace) %{_sysconfdir}/john.conf
%{_bindir}/*
%{_datadir}/%{name}

%changelog
* Mon Feb 14 2005 Abel Cheung <deaddog@mandrake.org> 1.6.37-1mdk
- New development version, with x86_64 and ppc support
- Tries optimization whenever possible, it gives me > 4x speed boost
  on my Athlon when compared with unoptimized 1.6 version
- Hope nobody is stupid enough to run it on non-MMX Pentium I
- Disable P0, devel version has PPC support, please test if it works
- Redo P1 (FHS)
- P2: Add EXTRA_CFLAGS for those who want to squeeze the last bit of
  CPU power

* Wed Aug 04 2004 Guillaume Rousse <guillomovitch@mandrake.org> 1.6-6mdk 
- rebuild

* Tue Mar  2 2004 Götz Waschk <waschk@linux-mandrake.com> 1.6-5mdk
- add generic as fallback target for amd64 and others

* Sat Feb 01 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.6-4mdk
- x86 sucks, we want it for ppc !
- Remake patch0 with ppc adaptation
- setting up for alpha/sparc (need test)

* Sat Jan 04 2003 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.6-3mdk
- rebuild

* Mon Dec 02 2002 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.6-2mdk
- config file in /etc
- fix configuration problem

* Mon Sep 16 2002 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.6-1mdk
- first mdk version
